zoukankan      html  css  js  c++  java
  • HDU 1079 Calendar Game (博弈论-sg)

    版权声明:欢迎关注我的博客,本文为博主【炒饭君】原创文章。未经博主同意不得转载 https://blog.csdn.net/a1061747415/article/details/32336485

    Calendar Game

    Problem Description
    Adam and Eve enter this year’s ACM International Collegiate Programming Contest. Last night, they played the Calendar Game, in celebration of this contest. This game consists of the dates from January 1, 1900 to November 4, 2001, the contest day. The game starts by randomly choosing a date from this interval. Then, the players, Adam and Eve, make moves in their turn with Adam moving first: Adam, Eve, Adam, Eve, etc. There is only one rule for moves and it is simple: from a current date, a player in his/her turn can move either to the next calendar date or the same day of the next month. When the next month does not have the same day, the player moves only to the next calendar date. For example, from December 19, 1924, you can move either to December 20, 1924, the next calendar date, or January 19, 1925, the same day of the next month. From January 31 2001, however, you can move only to February 1, 2001, because February 31, 2001 is invalid. 

    A player wins the game when he/she exactly reaches the date of November 4, 2001. If a player moves to a date after November 4, 2001, he/she looses the game. 

    Write a program that decides whether, given an initial date, Adam, the first mover, has a winning strategy. 

    For this game, you need to identify leap years, where February has 29 days. In the Gregorian calendar, leap years occur in years exactly divisible by four. So, 1993, 1994, and 1995 are not leap years, while 1992 and 1996 are leap years. Additionally, the years ending with 00 are leap years only if they are divisible by 400. So, 1700, 1800, 1900, 2100, and 2200 are not leap years, while 1600, 2000, and 2400 are leap years.
     

    Input
    The input consists of T test cases. The number of test cases (T) is given in the first line of the input. Each test case is written in a line and corresponds to an initial date. The three integers in a line, YYYY MM DD, represent the date of the DD-th day of MM-th month in the year of YYYY. Remember that initial dates are randomly chosen from the interval between January 1, 1900 and November 4, 2001. 
     

    Output
    Print exactly one line for each test case. The line should contain the answer "YES" or "NO" to the question of whether Adam has a winning strategy against Eve. Since we have T test cases, your program should output totally T lines of "YES" or "NO". 
     

    Sample Input
    3 2001 11 3 2001 11 2 2001 10 3
     

    Sample Output
    YES NO NO
     

    Source
     


    题目大意:

    给定日期。轮流来,能够在日期的月上加1,或者在天数上加1 ,假设约数上加1无效,自己主动转化为在天数上加1,轮流来,问先手是否赢?

    解题思路:

    这非常明显是道博弈题,对于SG的性质定义

    必胜态记为P。用数值0表示。当且仅当其后继都是 N,也就是SG()>0

    必输态记为N,用数值1表示,当且仅当其后继存在P,也就是SG()=0

    对于这题,全然不是必需这样用SG去推理。能够结合DP,用记忆化搜索划分为子问题,每一步取对自己最优的。

    解题代码:

    #include <iostream>
    #include <cstdio>
    #include <cstring>
    using namespace std;
    
    int dp[2100][15][40][2];
    const int day[]={0,31,28,31,30,31,30,31,31,30,31,30,31};
    
    int getday(int y,int m){
        if(m!=2) return day[m];
        else{
            if( ( y%4==0 && y%100!=0 ) || y%400==0 ) return day[m]+1;
            else return day[m];
        }
    }
    
    bool valid(int y,int m,int d){
        if(m>12){
            m=1;
            y++;
        }
        if( y>2001 || ( y==2001 && m>11 ) || (y==2001 && m==11 && d>4) || d>getday(y,m) ) return false;
        else return true;
    }
    
    int DP(int y,int m,int d,int f){
        if(m>12){
            m=1;
            y++;
        }
        if(getday(y,m)<d){
            d=1;
            m++;
            if(m>12){
                m=1;
                y++;
            }
        }
    
        if(y>=2001 && m>=11 && d>=4) return 1-f;
        if(dp[y][m][d][f]!=-1) return dp[y][m][d][f];
    
        int ans;
        if(f==0){
            ans=1;
            if( valid(y,m+1,d) && DP(y,m+1,d,1-f)<ans ) ans=DP(y,m+1,d,1-f);
            if( DP(y,m,d+1,1-f)<ans ) ans=DP(y,m,d+1,1-f);
        }else{
            ans=0;
            if( valid(y,m+1,d) && DP(y,m+1,d,1-f)>ans ) ans=DP(y,m+1,d,1-f);
            if( DP(y,m,d+1,1-f)>ans ) ans=DP(y,m,d+1,1-f);
        }
        return dp[y][m][d][f]=ans;
    }
    
    int main(){
        memset(dp,-1,sizeof(dp));
        int t,y,m,d;
        cin>>t;
        while(t-- >0){
            cin>>y>>m>>d;
            if ( DP(y,m,d,0) ) cout<<"NO"<<endl;
            else cout<<"YES"<<endl;
        }
        return 0;
    }
    





  • 相关阅读:
    JS组件系列——自己动手扩展BootstrapTable的treegrid功能
    JS组件系列——自己动手封装bootstrap-treegrid组件
    JS组件系列——又一款MVVM组件:Vue(二:构建自己的Vue组件)
    使用Advanced Installer制作IIS安装包(二:配置安装包依赖项和自定义dll)
    使用Advanced Installer制作IIS安装包(一:配置IIS和Web.config)
    C#组件系列——又一款日志组件:Elmah的学习和分享
    推荐一款带暂停功能的轮播组件,不要谢我,我叫红领巾!
    JS组件系列——又一款MVVM组件:Vue(一:30分钟搞定前端增删改查)
    CSS系列——前端进阶之路:初涉Less
    MVC系列——MVC源码学习:打造自己的MVC框架(四:了解神奇的视图引擎)
  • 原文地址:https://www.cnblogs.com/mqxnongmin/p/10571297.html
Copyright © 2011-2022 走看看